/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to you under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jorphan.collections;

import java.util.LinkedHashMap;

import org.junit.jupiter.api.Test;

public class CopyOnWriteMapTest {
    private Object map;
    private Object map2;

    private static final CopyOnWriteMap<CopyOnWriteMapTest, String, String> MAP =
            new CopyOnWriteMap<>(
                    LinkedHashMap::new,
                    v -> v,
                    x -> x.map,
                    (x, v) -> {
                        x.map = v;
                    },
                    x -> x.map2,
                    (x, v) -> {
                        x.map2 = v;
                    });

    public String get(String key) {
        return MAP.get(this, key);
    }

    @Test
    void hello() {
        MAP.set(this, "hello", "world");
        System.out.println("MAP.get(this, \"hello\") = " + MAP.get(this, "hello"));
    }
}
